/**
 * @modification $Date: 2004/06/25 17:56:46 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafBlurFilter.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2(GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;

//import java.awt.*;
//import java.awt.image.*;

public class SlafBlurFilter
  extends SlafGlobalFilter
{
  protected int computeColor(int pixels[],int size)
  {
    float redSum=0,greenSum=0,blueSum=0,alphaSum=0;
    for(int i=0;i<size;i++)
    {
      try
      {
        int pixel=pixels[i];
        redSum   +=DEFAULT_CM.getRed  (pixel);
        greenSum +=DEFAULT_CM.getGreen(pixel);
        blueSum  +=DEFAULT_CM.getBlue (pixel);
        alphaSum +=DEFAULT_CM.getAlpha(pixel);
      }
      catch(ArrayIndexOutOfBoundsException e)
      {
        System.err.println("Error in global image filter");
      }
    }

    int redAvg  =(int)(redSum   / size);
    int greenAvg=(int)(greenSum / size);
    int blueAvg =(int)(blueSum  / size);
    int alphaAvg=(int)(alphaSum / size);
    return (alphaAvg << 24)|(redAvg << 16)|
           (greenAvg << 8) |(blueAvg << 0);
  }
}
