/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafBumps.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;




import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;

class SlafBumps implements Icon, Serializable
{
  protected int   xBumps;
  protected int   yBumps;
  protected Color color;

  public SlafBumps(int _width, int _height, Color _color)
  {
    setBumpArea (_width,_height);
    setBumpColor(_color);
  }

  public void setBumpArea(Dimension _bumpArea)
  {
    setBumpArea(_bumpArea.width, _bumpArea.height);
  }

  public void setBumpArea(int _width, int _height)
  {
    xBumps=_width;
    yBumps=_height;
  }

  public void setBumpColor(Color _color)
  {
    color=_color;
  }

  public void paintIcon(Component c, Graphics g, int x, int y)
  {
    Rectangle oldClip    =g.getClipBounds();
    Rectangle desiredClip=new Rectangle(x,y,getIconWidth(),getIconHeight());
    Rectangle clip       =desiredClip.intersection(oldClip);

    g.setClip(clip.x,clip.y,clip.width,clip.height);

    Color cl=color.brighter();
    Color cd=color.darker();

    for(int i=clip.y/2*2;i<clip.y+clip.height;i+=2)
      for(int j=clip.x/2*2+(((i%4)/2)*2);j<clip.x+clip.width;j+=4)
      {
	g.setColor(cl);
	g.drawLine(j,i,j,i);
	g.setColor(cd);
	g.drawLine(j+1,i+1,j+1,i+1);
      }

    g.setClip(oldClip.x,oldClip.y,oldClip.width,oldClip.height);
  }

  public int getIconWidth()
  {
    return xBumps;
  }

  public int getIconHeight()
  {
    return yBumps;
  }
}
