/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafCheckBoxMenuItemUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.Serializable;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafCheckBoxMenuItemUI extends BasicCheckBoxMenuItemUI
{
  public static ComponentUI createUI(JComponent c)
  {
    return new SlafCheckBoxMenuItemUI();
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    SlafUtils.setOpaque(c);
    SlafUtils.setRollover((AbstractButton)c);
  }

  protected void paintBackground(Graphics g, AbstractButton b)
  {
    Rectangle r=SlafUtils.getFullRect  (b);
    int       t=SlafUtils.getStatus    (b);
    Color     c=SlafUtils.getBackground(b);
    SlafUtils.paintBackground(g,r,b,c,t);
  }
  
  public void update(Graphics g, JComponent c)
  {
    paintBackground(g,(AbstractButton)c);
    //g.setColor(SlafManager.getColor("CheckBoxMenuItem.foreground",Color.black));
    g.setColor(SlafUtils.getAdaptedForeground((AbstractButton)c,"CheckBoxMenuItem"));
    paint(g,c);
    SlafUtils.paintOver(g,(AbstractButton)c);
  }

  // Jdk 1.4 only ;-(
  protected void paintText
    (Graphics g, JMenuItem c, Rectangle textRect, String text)
  {
      SlafUtils.drawString
	  (g,text,
	   textRect.x,
	   textRect.y,"CheckBoxMenuItem",c);
  }
}
