/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafComboBoxCellRenderer.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;


import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.plaf.*;

import java.awt.*;
//import java.io.Serializable;

public class SlafComboBoxCellRenderer
    extends SlafListCellRenderer
	    //JLabel 
	    //implements ListCellRenderer //, Serializable, UIResource
{
  /*
  protected boolean enabled;
  protected boolean selected;
  protected boolean focused;
  */

  public SlafComboBoxCellRenderer()
  {
    //setOpaque(true);
  }

  protected Border getCellBorder()
  {
    return SlafManager.getBorder
	("ComboBoxCell.border",SlafManager.getBorder("ComboBox.cellBorder"));
  }

  protected Border getSelectedCellBorder()
  {
    return SlafManager.getBorder
	("ComboBoxCell.selectedBorder",SlafManager.getBorder
	 ("ComboBox.selectedCellBorder"));
  }

  public Component getListCellRendererComponent
    (JList   list, 
     Object  value,
     int     index, 
     boolean isSelected, 
     boolean cellHasFocus)
  {
    super.getListCellRendererComponent
      (list,value,index,isSelected,cellHasFocus);

    if(isSelected)
    {
      setBorder(getSelectedCellBorder());
    }
    else
    {
      setBorder(getCellBorder());
    }

    /*
    selected=isSelected;
    enabled =list.isEnabled();
    focused =cellHasFocus;

    setEnabled(enabled);
    setFont(list.getFont());
    setOpaque(true);
    setHorizontalAlignment(JLabel.LEFT);

    if(selected)
    {
      setBackground(list.getSelectionBackground());
      setForeground(list.getSelectionForeground());
      setBorder(getSelectedCellBorder());
    }
    else
    {
      setBackground(list.getBackground());
      setForeground(list.getForeground());
      setBorder(getCellBorder());
    }
	
    if(value instanceof Icon)
    {
      setIcon((Icon)value);
    }
    else
    {
      setText((value == null) ? "" : value.toString());
    }
    // if(cellHasFocus) setBorder(focusBorder);
    */

    return this;
  }

  public void setOpaque(boolean _state)
  {
    super.setOpaque(isOpaque());
  }

  public boolean isOpaque()
  {
    boolean r=true;
    if(selected) r=SlafManager.getBoolean("ComboBoxCell.selectionOpaque",true);
    else         r=SlafManager.getBoolean("ComboBoxCell.opaque",false);
    //System.err.println("IS_OPAQUE="+r);
    return r;
  }

  protected void paintBackground(Graphics g)
  {
    Rectangle r=SlafUtils.getFullRect  (this);
    Color     c=SlafUtils.getBackground(this);
    int       t=SlafUtils.ENABLED;
    if(selected) t=SlafUtils.SELECTED;
    //if(focused)  t=SlafUtils.PRESSED;
    //if(!enabled) t=SlafUtils.ENABLED;
    SlafUtils.paintBackground(g,r,this,c,t,"ComboBoxCell");
  }
  
  protected void paintFocus(Graphics g)
  {
    Rectangle r=SlafUtils.getViewRect(this);
    g.setColor(SlafManager.getColor("ComboBox.focus",getForeground()));
    g.drawLine(r.x, r.y+r.height-1, r.x+r.width-1, r.y+r.height-1);
  }

  public void paint(Graphics g)
  {
    paintBackground(g);
    super.paint(g);
    if(focused) paintFocus(g);
    //SlafUtils.paintOver(g,(AbstractButton)c);
  }
}



