/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafDesktopPaneUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafDesktopPaneUI extends BasicDesktopPaneUI
{
  public static ComponentUI createUI(JComponent x)
  {
    //System.err.println("$$$$$$ DESKTOPUI.createUI");
    return new SlafDesktopPaneUI();
  }

  public void installUI(JComponent c)
  {
    //System.err.println("$$$$$$ DESKTOPUI.installUI");
    super.installUI(c);
    SlafUtils.setOpaque(c);
  }

  public void paint(Graphics g, JComponent b)
  {
    //System.err.println("$$$$$$ DESKTOPUI.opaque="+b.isOpaque());
    //System.err.println("$$$$$$ DESKTOPUI.ui="+b.getUIClassID());
    paintBackground(g,b);
  }

  protected void paintBackground(Graphics g, JComponent b)
  {
    Rectangle r=SlafUtils.getFullRect(b);
    Color     c=SlafUtils.getBackground(b);
    int       t=SlafUtils.ENABLED;

    SlafUtils.paintBackground(g,r,b,c,t);
  }
}

