/**
 * @modification $Date: 2004/03/03 19:56:47 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafFeelOld.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import javax.swing.border.*;
import javax.swing.text.*;

public class SlafFeelOld
{
  public static void install(UIDefaults _table)
  {
    JTextComponent.KeyBinding[] fieldBindings=
    {
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_C, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.copyAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_V, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.pasteAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_X, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.cutAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionBackwardAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionForwardAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.previousWordAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.nextWordAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 
							   InputEvent.CTRL_MASK | 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionPreviousWordAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 
							   InputEvent.CTRL_MASK |
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionNextWordAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_A, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.selectAllAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_HOME, 0),
				    DefaultEditorKit.beginLineAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_END, 0),
				    DefaultEditorKit.endLineAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_HOME, 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionBeginLineAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_END, 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionEndLineAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0),
				    JTextField.notifyAction)
    };

    JTextComponent.KeyBinding[] multilineBindings = {
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_C, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.copyAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_V, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.pasteAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_X, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.cutAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionBackwardAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionForwardAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.previousWordAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.nextWordAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_LEFT, 
							   InputEvent.CTRL_MASK | 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionPreviousWordAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 
							   InputEvent.CTRL_MASK |
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionNextWordAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_A, 
							   InputEvent.CTRL_MASK),
				    DefaultEditorKit.selectAllAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_HOME, 0),
				    DefaultEditorKit.beginLineAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_END, 0),
				    DefaultEditorKit.endLineAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_HOME, 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionBeginLineAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_END, 
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionEndLineAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_UP, 0),
				    DefaultEditorKit.upAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_DOWN, 0),
				    DefaultEditorKit.downAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_PAGE_UP, 0),
				    DefaultEditorKit.pageUpAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_PAGE_DOWN, 0),
				    DefaultEditorKit.pageDownAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_UP,
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionUpAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_DOWN,
							   InputEvent.SHIFT_MASK),
				    DefaultEditorKit.selectionDownAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0),
				    DefaultEditorKit.insertBreakAction),
      new JTextComponent.KeyBinding(KeyStroke.getKeyStroke(KeyEvent.VK_TAB, 0),
				    DefaultEditorKit.insertTabAction)
    };

    Object[] defaults=
    {
      "TextField.keyBindings",         fieldBindings,
      "PasswordField.keyBindings",     fieldBindings,
      "TextArea.keyBindings",          multilineBindings,
      "TextPane.keyBindings",          multilineBindings,
      "EditorPane.keyBindings",        multilineBindings,
    };

    _table.putDefaults(defaults);
    //SlafUtils.trace("TABLE="+_table.size());
  }
}
