/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafHueFilter.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.image.*;

public class SlafHueFilter extends RGBImageFilter
{
  private int a1_,r1_,g1_,b1_;
  private int a2_,r2_,g2_,b2_;

  public SlafHueFilter(int rgb2)
  {
    this(rgb2&0xFF000000,rgb2);
  }

  public SlafHueFilter(int rgb1, int rgb2)
  {
    a1_=(rgb1 & 0xff000000) >>24;
    r1_=(rgb1 & 0x00ff0000) >>16;
    g1_=(rgb1 & 0x0000ff00) >> 8;
    b1_=(rgb1 & 0x000000ff)     ;
    a2_=(rgb2 & 0xff000000) >>24;
    r2_=(rgb2 & 0x00ff0000) >>16;
    g2_=(rgb2 & 0x0000ff00) >> 8;
    b2_=(rgb2 & 0x000000ff)     ;

    // canFilterIndexColorModel=true;
  }

  public int filterRGB(int x, int y, int rgb)
  {
    int a=(rgb & 0xff000000) >>24;
    int r=(rgb & 0x00ff0000) >>16;
    int g=(rgb & 0x0000ff00) >> 8;
    int b=(rgb & 0x000000ff)     ;

    int h=(299*r+587*g+114*b)/1000;

    r=((255-h)*r1_+h*r2_)/255;
    g=((255-h)*g1_+h*g2_)/255;
    b=((255-h)*b1_+h*b2_)/255;

    return (a<<24) | (r<<16) | (g<<8) | b;
  }
}
