/**
 * @modification $Date: 2004/06/11 19:23:24 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafInternalFrameTitlePaneBorder.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;


import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.basic.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.plaf.*;

public class SlafInternalFrameTitlePaneBorder extends AbstractBorder
{
  private String ui_;
  private Border enabled;
  private Border selected;
  private Border disabled;

  public SlafInternalFrameTitlePaneBorder()
    { this(null); }

  public SlafInternalFrameTitlePaneBorder(String _ui)
    { ui_=_ui; }

  private void setBorders(Component c)
  {
    if(ui_==null)
    {
      ui_="InternalFrameTitlePane";
      // ((JComponent)c).getUIClassID();
      // if(ui_.endsWith("UI")) ui_=ui_.substring(0,ui_.length()-2);
    }

    // SlafUtils.trace("%%% "+ui_);
    if(enabled ==null) enabled =SlafManager.getBorder(ui_+".enabledBorder");
    if(selected==null) selected=SlafManager.getBorder(ui_+".selectedBorder");
    if(disabled==null) disabled=SlafManager.getBorder(ui_+".disabledBorder");

    if(enabled ==null) enabled =new LineBorder(Color.yellow,2);
    if(selected==null) selected=enabled;
    if(disabled==null) disabled=enabled;
  }

  public void paintBorder(Component c, Graphics g, int x, int y, int w, int h)
  {
    setBorders(c);

    SlafInternalFrameTitlePane tp=null;
    if(c instanceof SlafInternalFrameTitlePane)
      tp=(SlafInternalFrameTitlePane)c;

    if((tp!=null)&&tp.isSelected())
      selected.paintBorder(c,g,x,y,w,h);
    else
    if(c.isEnabled())
      enabled.paintBorder(c,g,x,y,w,h);
    else
      disabled.paintBorder(c,g,x,y,w,h);
  }

  public Insets getBorderInsets(Component _c)
  {
    return getBorderInsets(_c,new Insets(0,0,0,0));
  }

  public Insets getBorderInsets(Component _c, Insets _insets)
  {
    setBorders(_c);

    Insets ebi=enabled.getBorderInsets (_c);
    Insets sbi=selected.getBorderInsets(_c);
    Insets dbi=disabled.getBorderInsets(_c);

    int ti=SlafUtils.max(ebi.top   ,sbi.top   ,dbi.top);
    int bi=SlafUtils.max(ebi.bottom,sbi.bottom,dbi.bottom);
    int li=SlafUtils.max(ebi.left  ,sbi.left  ,dbi.left);
    int ri=SlafUtils.max(ebi.right ,sbi.right ,dbi.right);

    _insets.top   =ti;
    _insets.left  =li;
    _insets.bottom=bi;
    _insets.right =ri;

    return _insets;
  }
}

