/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafLightBorder.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import javax.swing.border.*;
import java.awt.*;

public class SlafLightBorder extends AbstractBorder
{
  public static final int RAISED =0;
  public static final int LOWERED=1;

  protected int   margin;
  protected int   type;

  public SlafLightBorder()
  {
    this(RAISED,1);
  }

  public SlafLightBorder(int _t, int _m)
  {
    type=_t;
    margin=_m;
  }

  public void paintBorder(Component c, Graphics g,
			  int x, int y, int width, int height)
  {
         if(type==RAISED ) paintRaisedBevel (c, g, x, y, width, height);
    else if(type==LOWERED) paintLoweredBevel(c, g, x, y, width, height);
  }

  public Insets getBorderInsets(Component _c)
  {
    return getBorderInsets(_c,new Insets(0,0,0,0));
  }

  public Insets getBorderInsets(Component _c,Insets _insets)
  {
    _insets.top   =margin;
    _insets.left  =margin;
    _insets.bottom=margin;
    _insets.right =margin;

    return _insets;
  }

  public boolean isBorderOpaque() { return true; }

  protected void paintRaisedBevel
    (Component c, Graphics g, int x, int y, int w, int h)
  {
    Color old=g.getColor();
    g.translate(x,y);
    g.setColor(c.getBackground());
    g.draw3DRect(0,0,w-1,h-1,true);
    for(int i=1;i<margin;i++)
      g.drawRect(i,i,w-1-2*i,h-1-2*i);
    g.translate(-x,-y);
    g.setColor(old);
  }

  protected void paintLoweredBevel
    (Component c, Graphics g, int x, int y, int w, int h)
  {
    Color old=g.getColor();
    g.translate(x,y);
    g.setColor(c.getBackground());
    g.draw3DRect(0,0,w-1,h-1,false);
    for(int i=1;i<margin;i++)
      g.drawRect(i,i,w-1-2*i,h-1-2*i);
    g.translate(-x,-y);
    g.setColor(old);
  }
}
