/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafLineBorder.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import javax.swing.border.*;
import java.awt.*;

public class SlafLineBorder extends AbstractBorder
{
  public static final int SOLID=0;
  public static final int DOT  =1;

  protected int[] margin;
  protected int[] thickness;
  protected Color color;
  protected int   line;

  public SlafLineBorder(Color _c,int _t)
  {
    this(0,0,0,0,_t,_t,_t,_t,_c,SOLID);
  }

  public SlafLineBorder(int _m1, int _m2,int _m3,int _m4,
			int _t1, int _t2,int _t3,int _t4,
			Color _c, int _l)
  {
    margin   =new int[] { _m1,_m2,_m3,_m4 };
    thickness=new int[] { _t1,_t2,_t3,_t4 };
    color=_c;
    line=_l;
  }

  public void paintBorder(Component c, Graphics g,
			  int x, int y, int width, int height)
  {
    g.setColor(color==null ? c.getForeground() : color);

    if(line==SOLID)
    {
      for(int i=0;i<thickness[0];i++)
	g.drawLine(x,y+i,x+width-1,y+i);
      for(int i=0;i<thickness[1];i++)
	g.drawLine(x+i,y,x+i,y+height-1);
      for(int i=0;i<thickness[2];i++)
	g.drawLine(x,y+height-1-i,x+width-1,y+height-1-i);
      for(int i=0;i<thickness[3];i++)
	g.drawLine(x+width-1-i,y,x+width-1-i,y+height-1);
    }
    else
    {
      for(int i=0;i<thickness[0];i++)
	for(int j=x;j<x+width;j+=2)
	  g.drawLine(j,y+i,j,y+i);
      for(int i=0;i<thickness[1];i++)
	for(int j=y;j<y+height;j+=2)
	  g.drawLine(x+i,j,x+i,j);
      for(int i=0;i<thickness[2];i++)
	for(int j=x;j<x+width;j+=2)
	  g.drawLine(j,y+height-1-i,j,y+height-1-i);
      for(int i=0;i<thickness[3];i++)
	for(int j=y;j<y+height;j+=2)
	  g.drawLine(x+width-1-i,j,x+width-1-i,j);
    }
  }

  public Insets getBorderInsets(Component _c)
  {
    return getBorderInsets(_c,new Insets(0,0,0,0));
  }

  public Insets getBorderInsets(Component _c, Insets _insets)
  {
    _insets.top   =margin[0]+thickness[0];
    _insets.left  =margin[1]+thickness[1];
    _insets.bottom=margin[2]+thickness[2];
    _insets.right =margin[3]+thickness[3];

    return _insets;
  }

  public boolean isBorderOpaque() { return false; }
}
