/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafMonochromeFilter.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.image.*;

public class SlafMonochromeFilter extends RGBImageFilter
{
  private int rgb1_,rgb2_,lum1_,lum2_;

  public SlafMonochromeFilter()
  {
    this(0x00000000,0x00FFFFFF);
  }

  public SlafMonochromeFilter(int _rgb1, int _rgb2)
  {
    rgb1_=_rgb1;//&0x00FFFFFF;
    rgb2_=_rgb2;//&0x00FFFFFF;
    lum1_=lum(rgb1_);
    lum2_=lum(rgb2_);
    // canFilterIndexColorModel=false; // dithering
  }

  private static int lum(int _rgb)
  {
    int r=(_rgb>>16)&0xFF;
    int g=(_rgb>> 8)&0xFF;
    int b=(_rgb    )&0xFF;
    return (299*r+587*g+114*b)/1000;
  }

  public int filterRGB(int x, int y, int rgb)
  {
    if((rgb==rgb1_)||(rgb==rgb2_)) return rgb;

    int a=(rgb>>24)&0xFF;

    if(a<96)
    {
      rgb=0x00000000;
    }
    else
    {
      int h=lum(rgb);

      rgb=0xFF000000;

      /*
	h=(h*12)/10-25;
	if(h<  0) h=0;
	if(h>255) h=255;
      */

      if(lum1_==lum2_) h=128;
      else if(lum1_<lum2_) h=255*(h-lum1_)/(lum2_-lum1_);
      else                 h=255*(h-lum2_)/(lum1_-lum2_);

      if(h<  0) h=0;
      if(h>255) h=255;

           if(h<= 64)                        rgb|=rgb1_;
      else if(h>=224)                        rgb|=rgb2_;
      else if((h<=96)&&((x%2!=0)||(y%2!=0))) rgb|=rgb1_;
      else if((h<=160)&&((x+y)%2==0))        rgb|=rgb1_;
      else if((x%2==0)&&(y%2==0))            rgb|=rgb1_;
      else                                   rgb|=rgb2_;
    }

    return rgb;
  }
}
