/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafPanelUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
//import java.awt.event.*;
import java.beans.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

import javax.accessibility.Accessible;

public class SlafPanelUI
       extends BasicPanelUI
{
  private static final PanelUI panelUI=new SlafPanelUI();

  public static ComponentUI createUI(JComponent c)
  {
    //SlafUtils.trace(" PaneUI for "+c.getClass());

    /*
    if(c.getClass().getName().endsWith("JPanelPopup"))
      return new PMUI();
    else
    */
      return panelUI;
  }

  /*
  protected static class PMUI extends SlafPanelUI
  {
    protected void installDefaults(JPanel p)
    {
      super.installDefaults(p);
      SlafUtils.setOpaque(p,"PopupMenu",false);
      if(SlafManager.getInteger("PopupMenu.alpha",-1)!=-1)
        SlafUtils.forceOpaque(p,p.isOpaque());
    }

    protected void paintBackground(Graphics g, JComponent b)
    {
      super.paintBackground(g,b);

      if(SlafManager.getInteger("PopupMenu.alpha",-1)!=-1)
      {
	Rectangle r=SlafUtils.getFullRect(b);
	g.setColor(new Color(0,0,0,32));
        g.fillRect(r.x,r.y,r.width,r.height);
      }
    }
  }
  */

  protected void paintBackground(Graphics g, JComponent b)
  {
    if(Boolean.TRUE.equals(b.getClientProperty("SLAF_OPAQUE_PANEL")))
    {
      g.setColor(SlafManager.getColor("PopupMenu.background",Color.white));
      g.fillRect(0,0,b.getWidth(),b.getHeight());
    }

    if(b.isOpaque())
    {
      Color     c=SlafUtils.getBackground(b);
      Rectangle r=SlafUtils.getFullRect  (b);
      SlafUtils.paintBackground(g,r,b,c);

      c=b.getBackground();
      if(  !(c instanceof ColorUIResource)
	 &&(SlafManager.getInteger("Panel.textureType",-1)!=-1))
      {
	int alpha=SlafManager.getInteger("Panel.alpha",-1);
	if(alpha!=-1)
	{
	  g.setColor(new Color(c.getRed(),c.getGreen(),c.getBlue(),alpha));
	  g.fillRect(r.x,r.y,r.width,r.height);
	}
      }
    }
  }
  
  public void update(Graphics g, JComponent b)
  {
    paintBackground(g,b);
    paint(g,b);
  }
}
