/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafPopupMenuUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.beans.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafPopupMenuUI
  extends BasicPopupMenuUI
  implements PropertyChangeListener
{
  public static ComponentUI createUI(JComponent c)
  {
    SlafPopupMenuUI r=new SlafPopupMenuUI();
    return r;
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    c.addPropertyChangeListener(this);
    SlafUtils.setOpaque(c);
  }

  public void uninstallUI(JComponent c)
  {
    super.uninstallUI(c);
    c.removePropertyChangeListener(this);
  }

  /*
  public void popupMenuCanceled           (PopupMenuEvent _evt) { }
  public void popupMenuWillBecomeInvisible(PopupMenuEvent _evt) { }

  public void popupMenuWillBecomeVisible(PopupMenuEvent e)
  {
    Container q=popupMenu;
    for(int i=0;i<4;i++)
    {
      if((q instanceof JComponent)&&((JComponent)q).isOpaque()) q=null;
      if(q!=null) q=q.getParent();
    }
    if(  (q!=null)
       &&"javax.swing.Popup$HeavyWeightWindow"
	 .equals(q.getClass().getName()))
    {
      q=popupMenu.getParent();
      for(int i=0;i<2;i++)
      {
	if((q instanceof JComponent)&&!((JComponent)q).isOpaque())
	  ((JComponent)q).setOpaque(true);
      }
    }
  }
  */

  public void propertyChange(PropertyChangeEvent _evt)
  {
    JComponent c=(JComponent)_evt.getSource();
    Container  q=c;
    for(int i=0;i<4;i++)
    {
      if((q instanceof JComponent)&&((JComponent)q).isOpaque()) q=null;
      if(q!=null) q=q.getParent();
    }

    Boolean b=((q!=null)
	       &&"javax.swing.Popup$HeavyWeightWindow"
	       .equals(q.getClass().getName()))
      ? Boolean.TRUE
      : Boolean.FALSE;


    Container p=c.getParent();
    if(p instanceof JComponent)
    {
      ((JComponent)p).putClientProperty("SLAF_OPAQUE_PANEL",b);
      ((JComponent)p).setOpaque(false);
      if(!b.equals(c.getClientProperty("SLAF_NO_SHADOW")))
      {
	c.putClientProperty("SLAF_NO_SHADOW",b);
	//if(q instanceof Window) ((Window)q).pack();
	//c.invalidate();
	//((JPopupMenu)c).setPopupSize(c.getPreferredSize());
	/*
	if(Boolean.TRUE.equals(b)&&!q.isShowing())
	{
	  //System.err.println("RESIZE WINDOW");
	  c.invalidate();
	  p.invalidate();
	  q.setSize(p.getPreferredSize());
	  q.invalidate();
	  q.doLayout();
	  q.validate();
	}
	*/
      }
    }
  }

  protected void paintBackground(Graphics g, JComponent b)
  {
    SlafUtils.paintBackground(g,b);
  }

  public void paint(Graphics g, JComponent b)
  {
    paintBackground(g,b);
  }
}
