/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafProgressBarUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;


import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
//import javax.swing.event.*;
import java.awt.*;

public class SlafProgressBarUI
       extends BasicProgressBarUI
{
  protected static int progressBarWidth;

  public static ComponentUI createUI(JComponent c)
  {
    return new SlafProgressBarUI();
  }

  public void installUI(JComponent c)
  {
    progressBarWidth=SlafManager.getInteger("ProgressBar.width");
    // SlafUtils.trace("%%% PBW="+progressBarWidth);

    super.installUI(c);
    SlafUtils.setOpaque(c);
  }

  /*
  public void paint(Graphics g, JComponent c)
  {
    super.paint(g,c);

    Border border=SlafManager.getBorder("ProgressBar.progressBorder");

    if(border!=null)
    {
      JProgressBar      bar  =(JProgressBar)c;
      BoundedRangeModel model=bar.getModel();

      if(model.getValue()!=model.getMinimum())
      {
	Dimension         size =bar.getSize();
	Insets            i    =bar.getInsets();
	Rectangle         rect =new Rectangle(size);

	rect.x     +=i.left;
	rect.y     +=i.top;
	rect.width -=(i.right + rect.x);
	rect.height-=(i.bottom + rect.y);

	int amount=getAmountFull(i, rect.width, rect.height);

	if(bar.getOrientation()==JProgressBar.HORIZONTAL)
	  border.paintBorder(c,g,rect.x,rect.y,amount,rect.height);
	else
	  border.paintBorder(c,g,rect.x,rect.y,rect.width,amount);
      }
    }
  }
  */

  public void paint(Graphics g, JComponent c)
  {
    JProgressBar      bar  =(JProgressBar)c;
    BoundedRangeModel model=bar.getModel();

    if(model.getValue()!=model.getMinimum())
    {
      Border border=SlafManager.getBorder
	("ProgressThumb.border",
	 SlafManager.getBorder("ProgressBar.progressBorder"));

      /*
      boolean opaque=SlafManager.getBoolean
	("ProgressThumb.opaque",
	 SlafManager.getBoolean("ProgressBar.progressOpaque",false));
	 */

      // int gap=SlafManager.getInteger("ScrollBar.gap",3);

      Color bg=SlafManager.getColor
	("ProgressThumb.background",
	 SlafManager.getColor
	 ("ProgressBar.progressBackground",c.getForeground()));

      Dimension         size =bar.getSize();
      Insets            i    =bar.getInsets();
      Rectangle         rect =new Rectangle(size);

      rect.x     +=i.left;
      rect.y     +=i.top;
      rect.width -=(i.right + rect.x);
      rect.height-=(i.bottom + rect.y);
      
      int amount=0;
      int val=model.getValue();
      int max=model.getMaximum();
      int min=model.getMinimum();
      if(max>min)
	amount=100*(val-min)/(max-min);
	//getAmountFull(i, rect.width, rect.height);

      int tw=rect.width;

      if(bar.getOrientation()==JProgressBar.HORIZONTAL)
	rect.width=rect.width*amount/100;
      else
	rect.height=rect.height*amount/100;

      int t=SlafUtils.ENABLED;
      // true ? TMP @GDX
      SlafUtils.paintBackground(g,rect,c,bg,t,"ProgressThumb",true);

      g.setColor(bg);
      if(border!=null)
	border.paintBorder(c,g,rect.x,rect.y,rect.width,rect.height);

      if(bar.isStringPainted())
	paintString(g,rect.x,rect.y,tw,rect.height,rect.width,i);
    }
  }

  protected void paintBackground(Graphics g, JComponent b)
  {
    Rectangle r=SlafUtils.getFullRect  (b);
    Color     c=SlafUtils.getBackground(b);
    SlafUtils.paintBackground(g,r,b,c);
  }
  
  public void update(Graphics g, JComponent c)
  {
    paintBackground(g,c);
    paint(g,c);
    SlafUtils.paintOver(g,c);
  }

  public Dimension getPreferredSize(JComponent c)
  {
    JProgressBar bar=(JProgressBar)c;

    if(bar.getOrientation()==JProgressBar.VERTICAL)
      return new Dimension(progressBarWidth,progressBarWidth*3+10);
    else  // Horizontal
      return new Dimension(progressBarWidth*3+10,progressBarWidth);
  }
}

