/**
 * @modification $Date: 2004/01/26 18:17:33 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafScrollButton.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

public class SlafScrollButton extends SlafSpecialButton
{
  // private static Color shadowColor;
  // private static Color highlightColor;

  private boolean isFreeStanding=false;
  private int     buttonWidth;

  public SlafScrollButton(int direction, int width, boolean freeStanding)
  {
    super();

    Icon icon=null;

    switch(direction)
    {
      case SwingConstants.NORTH:
	icon=SlafManager.getIcon("ScrollButton.northIcon");
	break;
      case SwingConstants.SOUTH:
	icon=SlafManager.getIcon("ScrollButton.southIcon");
	break;
      case SwingConstants.EAST:
	icon=SlafManager.getIcon("ScrollButton.eastIcon");
	break;
      case SwingConstants.WEST:
	icon=SlafManager.getIcon("ScrollButton.westIcon");
	break;
    }

    setIcon(icon);

    buttonWidth   =width;
    isFreeStanding=freeStanding;
  }

  public String getUIClassID()
  {
    return "ScrollButtonUI";
  }

  public void setFreeStanding(boolean freeStanding)
  {
    isFreeStanding=freeStanding;
  }

  public Dimension getMinimumSize()
  {
    return getPreferredSize();
  }
  
  public Dimension getMaximumSize()
  {
    return new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE);
  }
    
  public int getButtonWidth()
  {
    return buttonWidth;
  }
}
