/**
 * @modification $Date: 2004/01/26 18:17:34 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafTableHeaderUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafTableHeaderUI extends BasicTableHeaderUI
{
  public static ComponentUI createUI(JComponent c)
  {
    return new SlafTableHeaderUI();
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    SlafUtils.setOpaque(c);
  }

  public void update(Graphics g, JComponent c)
  {
    Container p =c.getParent(); // viewport
    Rectangle r =null;
    Color     bg=SlafUtils.getBackground((JComponent)c);

    if(c.isOpaque())
    {
      if(p!=null) p=p.getParent(); // scrollpane

      if(p instanceof JComponent)
      {
	bg=SlafUtils.getBackground((JComponent)p);
	r=SlafUtils.getFullRect(c);
	/*
	//SlafUtils.trace("BG="+bg);
	g.setColor(bg);
	g.fillRect(r.x,r.y,r.width,r.height);
	//SlafUtils.paintBackground(g,r,c,bg);
	*/
	r=SwingUtilities.convertRectangle(c,r,p);
	SlafUtils.paintBackground(g,r,(JComponent)p,bg);
      }
    }

    JTableHeader h=(JTableHeader)c;
    int          n=h.getColumnModel().getColumnCount();

    bg=SlafManager.getColor("TableHeader.background",bg);
    for(int i=0;i<n;i++)
    {
      r=h.getHeaderRect(i);
      SlafUtils.paintBackground
	(g,r,h,bg,SlafUtils.ENABLED);
    }

    paint(g,c);
    //SlafUtils.paintOver(g,c);
  }
}
