/**
 * @modification $Date: 2004/03/03 19:56:47 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafTableUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.util.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import javax.swing.table.*;

public class SlafTableUI
  extends BasicTableUI
{
  public static ComponentUI createUI(JComponent c)
  {
    return new SlafTableUI();
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    LookAndFeel.installBorder(c,"Table.border");
    SlafUtils.setOpaque(c);

    TableCellRenderer tcr=(TableCellRenderer)
	SlafManager.getObject("Table.cellRenderer");

    JTable table=(JTable)c;

    if(tcr!=null)
    {
      table.setDefaultRenderer(Object    .class,tcr);
      table.setDefaultRenderer(Number    .class,tcr);
      table.setDefaultRenderer(Float     .class,tcr);
      table.setDefaultRenderer(Double    .class,tcr);
      table.setDefaultRenderer(Date      .class,tcr);
      table.setDefaultRenderer(Icon      .class,tcr);
      table.setDefaultRenderer(ImageIcon .class,tcr);
      table.setDefaultRenderer(Boolean   .class,tcr);

      table.setRowHeight
	(tcr.getTableCellRendererComponent
	 (table,"PpXxLl",false,false,0,0).getPreferredSize().height);
    }

    table.setIntercellSpacing
      (SlafManager.getSize
       ("Table.intercellSize",
	new DimensionUIResource(1,1)));

    /*
    TableCellRenderer hcr=((JTable)c).getTableHeader().getDefaultRenderer();
    Font hft=SlafManager.getFont("TableHeader.font");
    if(((JComponent)hcr).getFont() instanceof FontUIResource)
    {
      System.err.println("SET-FONT: "+hft);
      ((JComponent)hcr).setFont(hft);
    }
    */
  }

  public void update(Graphics g, JComponent c)
  {
    SlafUtils.paintBackground(g,c);
    paint(g,c);
    //SlafUtils.paintOver(g,c);
  }
}
