/**
 * @modification $Date: 2004/01/26 18:17:34 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafToolBarSeparatorUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import javax.swing.*;
import java.awt.*;
import javax.swing.plaf.*;

public class SlafToolBarSeparatorUI
       extends SlafSeparatorUI
{
  public static ComponentUI createUI(JComponent x)
  {
    return new SlafToolBarSeparatorUI();
  }

  protected void installDefaults(JSeparator c)
  {
    JToolBar.Separator s=(JToolBar.Separator)c;
    Dimension          t=s.getSeparatorSize();

    if((t==null)||(t instanceof UIResource))
      ((JToolBar.Separator)s).setSeparatorSize(getDefaultSize(s));
  }

  // bogue swing ui==null
  public Dimension getPreferredSize(JComponent c)
  {
    JToolBar.Separator s=(JToolBar.Separator)c;
    Dimension          r=s.getSeparatorSize();

    if((r==null)||(r instanceof DimensionUIResource))
      r=getDefaultSize(s);

    return r;
  }

  public static Dimension getDefaultSize(JToolBar.Separator s)
  {
    DimensionUIResource r;
    int w=SlafManager.getInteger("ToolBarSeparator.width" ,10);
    int h=SlafManager.getInteger("ToolBarSeparator.height",15);

    Container p=s.getParent();
    if((p instanceof JToolBar)&&
       (((JToolBar)p).getOrientation()==JToolBar.VERTICAL))
      r=new DimensionUIResource(h,w);
    else
      r=new DimensionUIResource(w,h);

    return r;
  }

  public Dimension getMinimumSize(JComponent c)
  {
    return getPreferredSize(c);
  }

  public Dimension getMaximumSize(JComponent c)
  {
    return getPreferredSize(c);
  }
}
