/**
 * @modification $Date: 2004/01/26 18:17:34 $
 * @statut       unstable
 * @file         com/memoire/slaf/SlafViewportUI.java
 * @version      0.20
 * @author       Guillaume Desnoix
 * @email        guillaume-desnoix@memoire.com
 * @license      GNU General Public License 2 (GPL2)
 * @copyright    1999-2004 Guillaume Desnoix
 */

package com.memoire.slaf;
import com.memoire.slaf.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;

public class SlafViewportUI
  extends BasicViewportUI
  implements ContainerListener
{
  public static ComponentUI createUI(JComponent x)
  {
    return new SlafViewportUI();
  }

  public void installUI(JComponent c)
  {
    super.installUI(c);
    SlafUtils.setOpaque(c);
    c.addContainerListener(this);
  }

  public void componentAdded(ContainerEvent _evt)
  {
    /*
    JComponent c=(JComponent)_evt.getChild(); // table, list, ...
    Container  p=_evt.getContainer();         // viewport

    String ui=c.getUIClassID();
    ui=ui.substring(0,ui.length()-2);
    Border b=SlafManager.getBorder(ui+".viewportBorder");

    p=p.getParent();
    if(p instanceof JScrollPane)
    {
      JScrollPane s=(JScrollPane)p;
      Border o=s.getViewportBorder();
      if((b!=null)&&((o==null)||(o instanceof BorderUIResource)))
      {
	System.err.println("------- B="+b);
	s.setViewportBorder(new LineBorder(Color.green,3));//b);
	c.setBorder(new BorderUIResource(new EmptyBorder(0,0,0,0)));
	c.revalidate();
      }
    }
    */
  }

  public void componentRemoved(ContainerEvent _evt)
  {
  }

  /*
  public void paint(Graphics g, JComponent b)
  {
    //paintBackground(g,b);
  }
  */

  protected void paintBackground(Graphics g, JComponent b)
  {
    if(b.isOpaque())
    {
      Rectangle r=SlafUtils.getFullRect(b);
      Color     c=SlafUtils.getBackground(b);
      SlafUtils.paintBackground(g,r,b,c);
    }
  }

  public void update(Graphics g, JComponent b)
  {
    paintBackground(g,b);
    paint(g,b);
  }
}
